'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _of = require('rxjs/observable/of');

var _throw2 = require('rxjs/observable/throw');

var ajaxCall = function ajaxCall(ajaxreq, success, cancel, error, retry) {
  if (cancel === undefined) {
    console.warn('AgileRequest warn: its nice if you have a cancel action in your request');
  }

  if (retry === undefined) {
    console.warn('AgileRequest warn: its nice if you have a retry action in your request');
  }

  var requestError = void 0;
  return ajaxreq.takeUntil(cancel).flatMap(function (result) {
    return success.map(function (s) {
      return s(result.data);
    });
  }).retryWhen(function (error) {
    return error.flatMap(function (error) {
      requestError = error;
      if (retry !== undefined) {
        /*
        if you have error status retry
        */
        if (retry(error)) {
          return (0, _of.of)(error.status);
        }
        return (0, _throw2._throw)(error.status);
      } else {
        /* 
        else all error will retry 
        */
        return (0, _of.of)(error.status);
      }
    })
    // we decide to retry 5x
    .take(5).concat((0, _throw2._throw)('Sorry, there was an error (after 5 retries)'));
  }).catch(function (message) {
    var err = {
      requestError: requestError,
      message: message
    };
    return (0, _of.of)(error(err));
  });
};

exports.default = ajaxCall;