'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteRequest = exports.putRequest = exports.patchRequest = exports.postRequest = exports.getRequest2 = exports.getRequest = undefined;

var _rxjs = require('rxjs');

var _ajax = require('rxjs/observable/dom/ajax');

var _concat = require('rxjs/observable/concat');

var _ajax2 = require('./ajax');

var _ajax3 = _interopRequireDefault(_ajax2);

var _of = require('rxjs/observable/of');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getRequest2 = function getRequest2(actions) {
  console.log(actions);
  return actions.action.ofType(actions.epic).switchMap(function () {
    var call = _ajax.ajax.get(actions.url, actions.header);
    var loading = (0, _of.of)(actions.loading());

    return (0, _concat.concat)(loading, (0, _ajax3.default)(call, actions.success, actions.cancel, actions.error, actions.retry));
  });
};

var getRequest = function getRequest(actions) {
  var call = _ajax.ajax.get(actions.url, actions.header);
  if (actions.loading === undefined) {
    console.error('AgileRequest error: loading action is required for the standard request');
  }
  return (0, _concat.concat)((0, _of.of)(actions.loading), (0, _ajax3.default)(call, actions.success, actions.cancel, actions.error, actions.retry));
};

var postRequest = function postRequest(actions) {
  var call = _ajax.ajax.post(actions.url, actions.formBody, actions.header);
  return (0, _concat.concat)((0, _of.of)(actions.loading), (0, _ajax3.default)(call, actions.success, actions.cancel, actions.error, actions.retry));
};

var patchRequest = function patchRequest(actions) {
  var call = _ajax.ajax.patch(actions.url, actions.formBody, actions.header);
  return (0, _concat.concat)((0, _of.of)(actions.loading), (0, _ajax3.default)(call, actions.success, actions.cancel, actions.error, actions.retry));
};

var putRequest = function putRequest(actions) {
  var call = _ajax.ajax.patch(actions.url, actions.formBody, actions.header);
  return (0, _concat.concat)((0, _of.of)(actions.loading), (0, _ajax3.default)(call, actions.success, actions.cancel, actions.error, actions.retry));
};

var deleteRequest = function deleteRequest(actions) {
  var call = _ajax.ajax.delete(actions.url, actions.header);
  return (0, _concat.concat)((0, _of.of)(actions.loading), (0, _ajax3.default)(call, actions.success, actions.cancel, actions.error, actions.retry));
};

exports.getRequest = getRequest;
exports.getRequest2 = getRequest2;
exports.postRequest = postRequest;
exports.patchRequest = patchRequest;
exports.putRequest = putRequest;
exports.deleteRequest = deleteRequest;